﻿using System;
using System.Windows.Input;
using System.Windows.Media;
using Microsoft.Phone.Controls;
using System.Windows.Resources;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
namespace P26_1
{
    public partial class MainPage : PhoneApplicationPage
    {
        //Для перемещения объекта
        double speedAndDirX = 0;
        double speedAndDirY = 0;
        //Для звуков и музыки
        SoundEffect sound;
        SoundEffect backMusic;
        //Используется для управления проигрыванием
        SoundEffectInstance backMusicInstance;
        public MainPage()
        {
            InitializeComponent();
            //Загружаем звуки
            LoadSound("Res/SoundFx1.wav", out sound);
            LoadSound("Res/Music.wav", out backMusic);
            //Работаем с SoundEffectInstance
            backMusicInstance = backMusic.CreateInstance();
            //Настраиваем параметры воспроизведения музыки
            backMusicInstance.IsLooped = true;
            backMusicInstance.Volume = 0.5f;
            //Запустим проигрывание музыки
            backMusicInstance.Play();
            //Изменим положение и скорость объекта
            ChangeDir();
            //Добавим обработчик события Rendering
            CompositionTarget.Rendering += new EventHandler(CompositionTarget_Rendering);
        }
        //В обработчике события Rendering
        void CompositionTarget_Rendering(object sender, EventArgs e)
        {
            //Выполним метод Update для обеспечения работоспособности XNA-механизмов
            FrameworkDispatcher.Update();
            //Изменим позицию объекта
            translate.X += speedAndDirX;
            translate.Y += speedAndDirY;
            //Проверим на столкновение объекта с границами экрана
            CheckBounds();
        }
        //При прикосновении к эллипсу
        private void ellipse1_Tap(object sender, GestureEventArgs e)
        {
            //Поменяем позицию, скорость, направление движения объекта
            ChangeDir();
            //Проиграем звук
            sound.Play();
        }

        void ChangeDir()
        {
            //Для работы со случайными числами
            Random r = new Random();
            //Получим новые значения направления и скорости
            speedAndDirX = r.Next(5) - r.Next(5);
            speedAndDirY = r.Next(5) - r.Next(5);
            //Установим объект в новую позицию на экране, не пересекая границ экрана
            translate.X = r.Next(700);
            translate.Y = r.Next(380);
        }
        //Проверим на столкновение с границами
        void CheckBounds()
        {
            //При пересечении границ инвертируем направление
            if (translate.X < 0 || translate.X > 700)
            {
                speedAndDirX = -speedAndDirX;
            }
            if (translate.Y < 0 || translate.Y > 380)
            {
                speedAndDirY = -speedAndDirY;
            }
        }
        //Загрузка звуковых ресурсов
        void LoadSound(string FilePath, out SoundEffect Sound)
        {
            //Сформируем информацию о потоке
            StreamResourceInfo SoundFileInfo = App.GetResourceStream(new Uri((FilePath), UriKind.Relative));
            //Создаем новый объект SoundEffect из потока
            Sound = SoundEffect.FromStream(SoundFileInfo.Stream);
        }

    }
}